package beantwortenvonnachrichten;

import java.io.*;
import java.util.Properties;
import javax.mail.*;
import javax.mail.internet.*;
/**
 * Title:        Beantworten einer Mail Message
 * Description:  Beispiel fr den Einsatz der reply() Methode
 * Copyright:    Copyright (c) J.M.Joller
 * Company:      Joller-Voss
 * @author J.M.Joller
 * @version 1.0
 */

public class Reply {
  public static void main (String args[]) throws Exception {
    System.out.println("[Reply]Start");
    /*
    String host = args[0];      // pop3.swissonline.ch
    String sendHost = args[1];  // joller-voss.ch
    String username = args[2];  // josef.m.joller
    String password = args[3];  // ??????????????
    String from = args[4];      // FBI
    */
    String host = "pop3.swissonline.ch";
    String sendHost = "joller-voss.ch";
    String username = "josef.m.joller";
    String password = "5nbjjhj_";
    String from = "Joller";

    // leere Properties
    System.out.println("[Reply]Setzen der Properties");
    Properties props = System.getProperties();
    props.put("mail.smtp.host", sendHost);

    // Bestimmen der Session
    System.out.println("[Reply]Session  instanzieren");
    Session session = Session.getDefaultInstance(props, null);

    // und des Stores
    System.out.println("[Reply]Store  instanzieren");
    Store store = session.getStore("pop3");
    store.connect(host, username, password);

    // und des Folders
    System.out.println("[Reply]Folder  instanzieren");
    Folder folder = store.getFolder("INBOX");
    folder.open(Folder.READ_ONLY);

    BufferedReader reader = new BufferedReader (
      new InputStreamReader(System.in));

    // Message Verzeichnis bestimmen
    System.out.println("[Reply]Message Verzeichnis");
    Message message[] = folder.getMessages();
    if (message.length < 1) System.out.println("[Reply]\tMessage Verzeichnis ist leer");
    for (int i=0, n=message.length; i<n; i++) {
       System.out.println(i + ": " + message[i].getFrom()[0]
         + "\t" + message[i].getSubject());

      System.out.println("Wollen Sie auf diese Meldung antworten? [JA oder/QUIT]");
      String line = reader.readLine();
      if ("JA".equals(line)) {

        // TODO : Antwort Message Objekt
        MimeMessage reply = (MimeMessage)message[i].reply(false);

        // TODO : 'From' Feld
        reply.setFrom(new InternetAddress(from));

        // TODO : Inhalt der Antwort (der alte Text wird hineinkopiert)
        //        Aber es wird nur Text kopiert
        MimeMessage orig = (MimeMessage)message[i];
        StringBuffer buffer = new StringBuffer("Danke\n\n");
        if (orig.isMimeType("text/plain")) {
          String content = (String)orig.getContent();
          StringReader contentReader = new StringReader(content);
          BufferedReader br = new BufferedReader(contentReader);
          String contentLine;
          while ((contentLine = br.readLine()) != null) {
            buffer.append("> ");
            buffer.append(contentLine);
            buffer.append("\r\n");
          }
        }

        // TODO : setzen des Inhalts
        reply.setText(buffer.toString());

        // TODO : senden der Meldung
        Transport.send(reply);

      } else if ("QUIT".equals(line)) {
        break;
      }
    }

    // Connection schliessen
    System.out.println("[Reply]Folder schliessen");
    folder.close(false); // kein purge der Meldungen
    System.out.println("[Reply]Store schliessen");
    store.close();
  }
}
