package lesenvonnachrichten;

import java.io.*;
import java.util.Properties;
import javax.mail.*;
import javax.mail.internet.*;

/**
 * Title: Lesen POP3 Nachrichten
 * Description:Musterlsung
 * Copyright:    Copyright (c) J.M.Joller
 * Company:      Joller-Voss GmbH
 * @author J.M.Joller
 * @version 1.0
 */
public class Lesen {
  public static void main (String args[]) throws Exception {
  /*
    String host = args[0];
    String username = args[1];
    String password = args[2];
  */
    String setup[] = {"mailhost.hta.fhz.ch", "jjoller", "*****************"};
    // properties
    Properties props = new Properties();
    String host = setup[0];
    String username = setup[1];
    String password = setup[2];

    // System Properties
    // Properties props = System.getProperties();

    // Mail Server
    props.put("mail.pop3.host", host);

    // session
    Session session = Session.getDefaultInstance(props, null);
    session.setDebug(true);

    // store
    Store store = session.getStore("pop3");

    // Connect to store
    store.connect(host, username, password);

    // Get folder
    Folder folder = store.getFolder("INBOX");

    // Open read-only
    folder.open(Folder.READ_ONLY);

    BufferedReader reader = new BufferedReader (
      new InputStreamReader(System.in));

    // Directory
    Message message[] = folder.getMessages();

    for (int i=0, n=message.length; i<n; i++) {

       // Display from und subject
       System.out.println(i + ": " + message[i].getFrom()[0]
         + "\t" + message[i].getSubject());

      System.out.println("Moechten Sie die Nachricht lesen? [JA zum Lesen/QUIT falls nicht]");
      String line = reader.readLine();
      if ("JA".equals(line)) {

        // Display message content
        System.out.println(message[i].getContent());

      } else if ("QUIT".equals(line)) {
        break;
      }
    }

    // Close connection
    //folder.close(false);
    folder.close(false);
    store.close();
  }
}