package nachrichtenattachmentsanhaengen;

import java.util.Properties;
import javax.mail.*;
import javax.mail.internet.*;
import javax.activation.*;

/**
 * Title:        Attachments in JavaMail
 * Description:  Beispiel fr die Behandlung von Attachments in JavaMail
 * Copyright:    Copyright (c) J.M.Joller
 * Company:      Joller-Voss
 * @author J.M.Joller
 * @version 1.0
 */

public class Attach {
  public static void main (String args[]) throws Exception {
    String host = args[0];
    String from = args[1];
    String to = args[2];
    String filename = args[3];

    // Bestimmen / Setzen der System Eigenschaften
    Properties props = System.getProperties();

    // Angaben zum Mail Server
    props.put("mail.smtp.host", host);

    // bestimmen der Session / Instanzieren der Session Klasse
    Session session = Session.getInstance(props, null);

    // TODO : Definieren der Message
    Message message = new MimeMessage(session);
    message.setFrom(new InternetAddress(from));
    message.addRecipient(Message.RecipientType.TO,
      new InternetAddress(to));
    message.setSubject("Hallo JavaMail Attachment");

    // TODO : Kreieren der message Bestandteile
    BodyPart messageBodyPart = new MimeBodyPart();

    // TODO : Eingabe der Meldung
    messageBodyPart.setText("Auch mir geht's gut!");

    // TODO : Kreieren der Multipart Message
    Multipart multipart = new MimeMultipart();

    // TODO : Part 1 hinzufgen
    multipart.addBodyPart(messageBodyPart);

    // TODO : Part 2 (Attachment) hinzufgen

    // TODO : kreieren eines Multiparts
    messageBodyPart = new MimeBodyPart();

    // TODO : bestimmen der Attachments
    DataSource source = new FileDataSource(filename);

    // TODO : setzen des Data Handlers auf das Attachment
    messageBodyPart.setDataHandler(new DataHandler(source));

    // TODO : setzen des Dateinamens
    messageBodyPart.setFileName(filename);

    // TODO : Teil zwei hinzufgen
    multipart.addBodyPart(messageBodyPart);

    // TODO : Teile zu einer Message zusammenfgen
    message.setContent(multipart);

    // TODO : senden der Message
    Transport.send(message);
  }
}
