package sendenvonhtmlmitbild;

import java.util.Properties;
import javax.mail.*;
import javax.mail.internet.*;
import javax.activation.*;

/**
 * Title:        JavaMail einer HTML Seite mit Image
 * Description:  Senden einer HTML Seite, mit Bild, als eine JavaMail Message (Multipart Message mit Content ID fr das Attachment).
 * Copyright:    Copyright (c) J.M.Joller
 * Company:      Joller-Voss
 * @author J.M.Joller
 * @version 1.0
 */

public class HtmlmitImageMessage {
  public static void main (String args[]) throws Exception {
    String host = args[0];
    String from = args[1];
    String to = args[2];
    String file = args[3]; //javalogo52x88.gif

    // Bestimmen der System Properties
    Properties props = System.getProperties();

    // Mail Server
    props.put("mail.smtp.host", host);

    // Session
    Session session = Session.getDefaultInstance(props, null);

    // Message
    Message message = new MimeMessage(session);

    // Headers
    message.setSubject("Embedded Image");
    message.setFrom(new InternetAddress(from));
    message.addRecipient(Message.RecipientType.TO, new InternetAddress(to));

    // Message Parts
   BodyPart messageBodyPart = new MimeBodyPart();

    // HTML Inhalt mit Referenz auf das Attachment (Bild)
    String htmlText = "<H1>Danke</H1>" +
      "<img src=\"cid:bild\">";

    // Content des Body Parts
    messageBodyPart.setContent(htmlText, "text/html");

    // Multipart definieren : ----------------------------------------
    MimeMultipart multipart = new MimeMultipart("related");

    // Body Part dem Multipart hinzufgen
    multipart.addBodyPart(messageBodyPart);

    // Image Part definieren
    messageBodyPart = new MimeBodyPart();

    // Lesen des Images und Zuordnung an den Part
    DataSource fds = new FileDataSource(file);
    messageBodyPart.setDataHandler(new DataHandler(fds));

    // Header Verbindung zum HTML
    messageBodyPart.setHeader("Content-ID","bild"); // wie beim Header

    // Dem Multipart Objekt hinzufgen
    multipart.addBodyPart(messageBodyPart);

    // Multipart mit Message assoziieren
    message.setContent(multipart);

    // Message senden
    Transport.send(message);

  }
}
